function checkIt(resp) {
    if ( parseInt(resp.status / 100, 10) === 2) {
	    return resp;
	} else {
  		throw resp;
	}
}

function catchIt(err) {
	if ( parseInt(err.status / 500, 10) === 5 ){
		return err;
	} else {
		throw err;
	}
}

class Net {
	constructor(baseURL) {
		this.baseURL = baseURL;
	}

	get(url) {
		url = this.baseURL + url;
		return window.fetch(url, {method: 'GET'}).then(checkIt).catch(catchIt).then((r) => r.json())
	}

	post(url, body) {
		let urb = this.baseURL + url;
		return window.fetch(urb, {
			method: 'POST',
			headers: {
				'Content-Type':'application/json'
			},
			body: JSON.stringify(body)
		}).then((r) => r.json());
	}

	put(url, body) {
		let urb = this.baseURL + url;
		return window.fetch(urb, {
			method: 'PUT',
			headers: {
				'Content-Type':'application/json'
			},
			body: JSON.stringify(body)
		})
		.then((r) => r.json());
	}

	del(url) {
		let urb = this.baseURL + url;
		return window.fetch(urb, {
			method: 'DELETE',
			headers: {
				'Content-Type':'application/json'
			}
		});
	}
}

export default new Net('/api/');